package obdelniky;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Random;
import javax.swing.JPanel;
import javax.swing.JOptionPane;

/**
 *
 * @author petr
 */
public class PanelObdelniku extends JPanel {

    final int minRectangleWidth = 10;
    final int minRectangleHeight = 10;
    private int pocetObdelniku;
    Random generator;

    public PanelObdelniku(int pocet) {
        this.pocetObdelniku = pocet;
        generator = new Random();
        addMouseListener(new MouseAdapter() {

            public void mouseClicked(MouseEvent e) {
                pocetObdelniku = askForRectangeCount(PanelObdelniku.this,pocetObdelniku);
                repaint();
            }
        });
    }

    @Override
    public Dimension getPreferredSize() {
        return new Dimension(600, 400);
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        if(this.getWidth() <= minRectangleWidth) return;
        if(this.getHeight() <= minRectangleHeight) return;
        for (int i = 0; i < pocetObdelniku; i++) {
            int x = generator.nextInt(this.getWidth()-minRectangleWidth);
            int y = generator.nextInt(this.getHeight()-minRectangleHeight);
            int w = generator.nextInt(this.getWidth() - x);
            int h = generator.nextInt(this.getHeight() - y);
            g.setColor(new Color(generator.nextInt(256),
                                 generator.nextInt(256),generator.nextInt(256)));
            g.fillRect(x, y, w, h);
        }
    }

    public static int askForRectangeCount(Component comp, int pocet) {
        do {
            String count = (String) JOptionPane.showInputDialog(comp, "Zadejte počet obdélníků:",
                    String.format("Hodnota musí být 1 až %d", Integer.MAX_VALUE),
                    JOptionPane.QUESTION_MESSAGE, null, null, pocet);
            if (count == null) {
                return 0;
            }
            try {
                pocet = Integer.parseInt(count);
            } catch (Exception NumberFormatException) {
                JOptionPane.showMessageDialog(comp, "Zadejte platné číslo!",
                        "Chyba vstupu", JOptionPane.ERROR_MESSAGE);
                continue;
            }
            if (pocet < 1) {
                JOptionPane.showMessageDialog(comp, "Zadejte kladné číslo!",
                        "Chyba vstupu", JOptionPane.ERROR_MESSAGE);
            }
        } while (pocet < 1);
        return pocet;
    }
}
